Subject: Re: [PATCH net-next 5/8] net/mlx5e: Expose the VF/SF RX drop counter on the representor

From: Rahul Rameshbabu <[email-masked]>
Date: Tue, 02 Apr 2024 11:02:21 -0700

On Mon, 01 Apr, 2024 08:03:15 -0700 Jakub Kicinski <[email-masked]> wrote:
> On Sun, 31 Mar 2024 21:52:06 +0300 Tariq Toukan wrote:
>> >> Hi Carolina and Tariq,
>> >>
>> >> I am wondering if any consideration was given to making this
>> >> a generic counter. Buffer exhaustion sounds like something that
>> >> other NICs may report too.  
>> > 
>> > I think it's basically rx_missed_errors from rtnl_link_stats64.
>> > mlx5 doesn't currently report it at all, AFAICT.
>> 
>> We expose it in ethtool stats.
>> Note that the "local" RX buffer exhaustion counter exists for a long time.
>> 
>> Here we introduce in the representor kind of a "remote" version of the 
>> counter, to help providers monitor RX drops that occur in the customers' 
>> side.
>> 
>> It follows the local counter hence currently it is not generic.
>
> I thought you'd say that, but we can't apply the rules selectively.
> Everyone has "local" counters already when we add the generic ones.
> Especially when we start broadening the "have" to encompass other
> generations of HW / netdev instance types.

In the normal case, we actual misreport out_of_buffer as rx_dropped....
Carolina is working on a fix for that.

  https://git.kernel.org/pub/scm/linux/kernel/git/netdev/net.git/tree/drivers/net/ethernet/mellanox/mlx5/core/en_main.c?id=ea2a1cfc3b2019bdea6324acd3c03606b60d71ad#n3793

With regards to the case for VF/SF representors, we will be adding
support for reporting the out_of_buffer statistics through the
rx_missed_errors counter as well.

--
Thanks,

Rahul Rameshbabu